/**
 * Doubly Linked List implementation.
 *
 * Unlike a singly linked list, we cannot use JS objects to store the next and previous
 * nodes. Singly linked list stores the next node object and creates a nested
 * tree - one node storing the next node which stores the next.
 *
 * Using this pattern for a doubly linked list results in a circular duplication of
 * objects. The next node is an object which stores the tree from the current node;
 * however, the previous property of the next node stores this current node which
 * internally stores the next node which internally stores this current node and so on.
 *
 * The problem being that we store objects in the previous and next properties and not
 * pointers.
 *
 * Hence, to make this implementation more efficient, we'll use a the following logic -
 * - Each node will be represented by a unique ID (insertion order number)
 * - A normal object will store this id and the node as a value
 * - The previous and next properties of a node will store the node IDs instead of the
 * node themselves.
 *
 * This also means that the nodes cannot insert after/before themselves as they
 * can't keep track of the unique Ids.
 *
 * This logic will be transparent to the consumer, internally we are using an extra
 * data structure and reducing the memory footprint.
 *
 * This also means that we cannot have an independent class for the list node because
 * the class is dependent on the unique ids generated by the list.
 *
 * @author Gautam Bhutani (buildthedesign@gmail.com)
 */


/**
 * Doubly Linked List implementation
 *
 * @export DoublyLinkedList Doubly Linked List
 * @class DoublyLinkedList
 */
export default class DoublyLinkedList {
    constructor() {
        this._internals = {
            nodeCounter: 0,
            nodeMapper: {},
            size: 0
        };
        this._head = this._tail = null;
    }
    /**
     * Get a new instance to List Node
     *
     * @params nodeValue {Object} new node value
     */
    getListNode = (value = null) => {
        const listInternals = this._internals;
        class ListNode {
            constructor(nodeValue = null) {
                this.nodeValue = nodeValue;
                this.previousNode = null;
                this.nextNode = null;
                this.uniqueId = ++listInternals.nodeCounter;
                listInternals.nodeMapper[this.id] = this;
            }
            /**
             * Get the node id
             *
             * @returns id {Int} unique node id
             */
            get id() {
                return this.uniqueId;
            }
            /**
             * Get the node value
             *
             * @returns value {Object} node value
             */
            get value() {
                return this.nodeValue;
            }
            /**
             * Set the node value
             *
             * @param nodeValue {Object} node value
             */
            set value(nodeValue) {
                this.nodeValue = nodeValue;
            }
            /**
             * Get the previous node
             *
             * @returns node {ListNode} previous node
             */
            get previous() {
                return listInternals.nodeMapper[this.previousNode] || null;
            }
            /**
             * Set the previous node
             *
             * @param node {ListNode} previous node
             */
            set previous(previousNode) {
                this.previousNode = previousNode ? previousNode.id : previousNode;
            }
            /**
             * Get the next node
             *
             * @returns node {ListNode} next node
             */
            get next() {
                return listInternals.nodeMapper[this.nextNode] || null;
            }
            /**
             * Set the next node
             *
             * @param node {ListNode} next node
             */
            set next(nextNode) {
                this.nextNode = nextNode ? nextNode.id : nextNode;
            }
        }
        const dataNode = new ListNode(value);
        dataNode.delete = () => this.delete(dataNode);
        dataNode.insertBefore = nodeValue => {
            const previousNode = this.getListNode(nodeValue);
            previousNode.previous = dataNode.previous;
            previousNode.next = dataNode;
            dataNode.previous = previousNode;
            if (dataNode === this._head) {
                this._head = this._head.previous;
            }
            this._internals.size++;
        };
        dataNode.insertAfter = nodeValue => {
            const nextNode = this.getListNode(nodeValue);
            nextNode.next = dataNode.next;
            dataNode.next = nextNode;
            nextNode.previous = dataNode;
            if (dataNode === this._tail) {
                this._tail = this._tail.next;
            }
            this._internals.size++;
        };
        return dataNode;
    }
    /**
     * Insert a node as the head
     *
     * @param nodeValue {Object} head node value
     */
    insertHead = (nodeValue = null) => {
        const dataNode = this.getListNode(nodeValue);
        dataNode.next = this._head;
        if (this._head !== null) {
            this._head.previous = dataNode;
        }
        this._head = dataNode;
        if (this._tail === null) {
            this._tail = this._head;
        }
        this._internals.size++;
    }
    /**
     * Insert a node to the end of the list
     *
     * @param nodeValue {Object} new node value
     */
    insert = (nodeValue = null) => {
        const dataNode = this.getListNode(nodeValue);
        if (this._head === null || this._tail === null) {
            this._head = this._tail = dataNode;
        } else {
            dataNode.previous = this._tail;
            this._tail.next = dataNode;
            this._tail = this._tail.next;
        }
        this._internals.size++;
    }
    /**
     * Find a value in the list
     *
     * @param nodeValue {Object} value to be searched
     * @returns ListNode {ListNode} node if value is found, null if value is not found
     */
    find = nodeValue => {
        let currentNode = this._head;
        while (currentNode !== null) {
            if (currentNode.value === nodeValue) {
                return currentNode;
            }
            currentNode = currentNode.next;
        }
        return null;
    }
    /**
     * Delete a node
     *
     * @param dataNode {ListNode} node to be deleted
     */
    delete = dataNode => {
        if (dataNode === null || typeof dataNode === 'undefined') {
            // No data node passed in.
            return;
        }
        const previousNode = dataNode.previous;
        const nextNode = dataNode.next;
        if (previousNode) {
            previousNode.next = nextNode;
        } else {
            // This is the first node
            this._head = nextNode;
        }
        if (nextNode) {
            nextNode.previous = previousNode;
        } else {
            // This is the last node
            this._tail = previousNode;
        }
        delete this._internals.nodeMapper[dataNode.id];
        this._internals.size--;
        return;
    }
    /**
     * Get the first node
     *
     * @returns node {ListNode} the head node
     */
    get head() {
        return this._head;
    }
    /**
     * Get the tail node
     *
     * @returns node {ListNode} the tail node
     */
    get tail() {
        return this._tail;
    }
    /**
     * Get the size of the list
     *
     * @returns size {Int} the list size
     */
    get size() {
        return this._internals.size;
    }
}
